# Vulnerability
libdwarf Integer Overflow

# Version
libdwarf 20160613

# Address Sanitizer Output
<0> tag: 17 DW_TAG_compile_unit  name: "addrmap.c" FORM 0xe "DW_FORM_strp"
<1> tag: 46 DW_TAG_subprogram  name: "addr_map_insert" FORM 0xe "DW_FORM_strp"
ASAN:SIGSEGV
=================================================================
==6825== ERROR: AddressSanitizer: SEGV on unknown address 0x0583903c (pc 0xb61f1a98 sp 0xbfa388b4 bp 0xbfa38d08 T0)
AddressSanitizer can not provide additional info.
    #0 0xb61f1a97 (/usr/lib/i386-linux-gnu/libasan.so.0+0x1ba97)
    #1 0xb61e3c0b (/usr/lib/i386-linux-gnu/libasan.so.0+0xdc0b)
    #2 0x80a21b1 in _dwarf_get_size_of_val /home/fuzzing/fuzzing/dwarf-20160613/libdwarf/dwarf_util.c:210
    #3 0x8054214 in _dwarf_next_die_info_ptr /home/fuzzing/fuzzing/dwarf-20160613/libdwarf/dwarf_die_deliv.c:1340
    #4 0x80557a5 in dwarf_child /home/fuzzing/fuzzing/dwarf-20160613/libdwarf/dwarf_die_deliv.c:1640
    #5 0x804b23f in get_die_and_siblings /home/fuzzing/fuzzing/dwarf-20160613/dwarfexample/./simplereader.c:573
    #6 0x804b2a8 in get_die_and_siblings /home/fuzzing/fuzzing/dwarf-20160613/dwarfexample/./simplereader.c:579
    #7 0x804b0a3 in read_cu_list /home/fuzzing/fuzzing/dwarf-20160613/dwarfexample/./simplereader.c:547
    #8 0x804ab10 in main /home/fuzzing/fuzzing/dwarf-20160613/dwarfexample/./simplereader.c:475
    #9 0xb600da82 (/lib/i386-linux-gnu/libc.so.6+0x19a82)
    #10 0x8049040 in _start (/home/fuzzing/fuzzing/dwarf-20160613/dwarfexample/simplereader+0x8049040)
SUMMARY: AddressSanitizer: SEGV ??:0 ??
==6825== ABORTING

# PoC
See poc

# Analysis
From the call stack we get to know the "val_ptr" caused the Access Violation directly. When we analyzed further, we found this was caused by a integer overflow in dwarf_die_deliv.c. Let's see the line 1354:
"info_ptr += sizeofval;"
In our case, sizeofval will be a very large value and when info_ptr adds this large value, it will cause an overflow and thus we checked the info_ptr with die_info_end, info_ptr will always less than die_info_end.
See the debug info below:
"
Hardware watchpoint 3: info_ptr
Old value = (Dwarf_Byte_Ptr) 0xb5003b35 "\001U\003Q\001"
New value = (Dwarf_Byte_Ptr) 0x603903a <error: Cannot access memory at address 0x603903a>
_dwarf_next_die_info_ptr (die_info_ptr=0xb5003b22 "\002\207", cu_context=0xb4e03d88, die_info_end=0xb5003db1 "", cu_info_start=0x0, want_AT_sibling=0, 
    has_die_child=0xbfffeb10, next_die_ptr_out=0xbfffead0, error=0xbfffec80) at dwarf_die_deliv.c:1355
1355                if (info_ptr > die_info_end) {
(gdb) print sizeofval 
$3 = 1359172869
(gdb) print info_ptr 
$4 = (Dwarf_Byte_Ptr) 0x603903a <error: Cannot access memory at address 0x603903a>
"
(Note that info_ptr is a Dwarf_Byte_Ptr and sizeofval is Dwarf_Unsigned)
Later, the program will use this corrupt info_ptr to memcpy.

# Report Timeline
2016.09.18: Shi Ji(@Puzzor) discovered this issue

# Credit
Shi Ji(@Puzzor)

# PoC
Contact us if you need PoC file